<template>
    <div class="container" :class="{'loading': loading}">
        <div class="row">
            <div class="col-lg-3">
                <h1 class="my-4">Products Catalog</h1>
                <div class="list-group">
                    <label for="title">Title:</label>
                    <input type="text" v-model="params.title" class="form-input" placeholder="Search title.." v-on:keyup.enter="loadProducts()" />

                    <label for="author">Author:</label>
                    <input type="text" v-model="params.author" class="form-input" placeholder="Search author.." v-on:keyup.enter="loadProducts()" />

                    <label for="date">Date:</label>
                    <input type="date" v-model="params.date" class="form-date" v-on:keyup.enter="loadProducts()" />

                    <button id="searchBtn" @click="loadProducts" class="btn btn-primary">Search</button>
                </div>
            </div>
            <div class="col-lg-9">
                <div class="row">
                    <div class="col-lg-9"></div>
                    <div class="col-lg-3">
                        <select id="sort" name="sort" v-model="params.sortBy" class="form-control" @change="loadProducts()">
                            <option disabled value="">Please select order</option>
                            <option value="titleAsc">Title (ASC)</option>
                            <option value="titleDesc">Title (DESC)</option>
                            <option value="dateAsc">Date (ASC)</option>
                            <option value="dateDesc" selected>Date (DESC)</option>
                        </select>
                    </div>
                </div>
                <div class="row mt-4">
                    <div class="col-lg-4 col-md-6 mb-4" v-for="product in products">
                        <div class="card h-100">
                            <a href="#">
                                <img class="card-img-top" src="http://placehold.it/700x400" alt="">
                            </a>
                            <div class="card-body">
                                <h4 class="card-title">
                                    <a v-bind:href="'/products/'+ product.id">{{ product.title }}</a>
                                </h4>
                                <h5>$ {{ product.price }}</h5>
                                <p class="card-text">{{ product.description }}</p>
                                <small>posted by: <b>{{ product.user.name }}</b></small>
                                <br>
                                <small>{{ product.created_date }}</small>
                            </div>
                        </div>
                    </div>
<!--                    <Pagination :data="products" @pagination-change-page="loadProducts"></Pagination>-->
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    data: function () {
        return {
            products: [],
            params: {
                page: 1,
                title: '',
                author: '',
                created_date: '',
                sortBy: 'dateDesc',
                // Authorization: 'Bearer' + this.token
            },
            loading: true,
        }
    },

    watch: {
        params: {
            handler () {
                this.loadProducts();
            }
        }
    },

    mounted() {
        this.loadProducts();
    },

    methods: {
        loadProducts: function () {
            const token = localStorage.getItem('user-token') || '';
            axios.defaults.headers.common['Authorization'] = 'Bearer ' + token;

            axios.get('/api/products',
                {
                    params: this.params,
                })
                .then((response) => {
                    if (response.data.statusCode == 200) {
                        this.products = response.data.content.items;
                        this.loading = false;
                    }
                })
                .catch(function (error) {
                    console.log(error);
                });
        },
    },
    beforeRouteEnter(to, from, next) {
        const token = localStorage.getItem('user-token') || '';

        if (!token && !window.Laravel.isLoggedin) {
            window.location.href = "/login";
        }
        next();
    }
}
</script>
